Attribute VB_Name = "basExcelPrn"
Option Explicit

'----------------------------------------
' Windows API
'----------------------------------------
'Kernel32.dll
Private Declare Function GetPrivateProfileString Lib "kernel32.dll" _
    Alias "GetPrivateProfileStringA" _
   (ByVal lpAppName As String _
  , ByVal lpKeyName As String _
  , ByVal lpDefault As String _
  , ByVal lpReturnedString As String _
  , ByVal nSize As Long _
  , ByVal lpFileName As String) As Long

Private Declare Function WritePrivateProfileString Lib "kernel32.dll" _
    Alias "WritePrivateProfileStringA" _
   (ByVal lpAppName As String _
  , ByVal lpKeyName As String _
  , ByVal lpString As String _
  , ByVal lpFileName As String) As Long

'----------------------------------------
' 萔`
'----------------------------------------
'bZ[Wo
Public Const MSG_WARNING                As String = "x"
Public Const MSG_ERROR                  As String = "G["

'----------------------------------------
' ϐ`
'----------------------------------------
'ADODB RlNV
Public pobjCn                           As Object

'*******************************************************************************
' Sub Main()
'
' N
'*******************************************************************************
Sub Main()
    Dim blnRet                          As Boolean
    Dim strDSN                          As String
    Dim strUID                          As String
    Dim strPWD                          As String

    'AvP[V̕N֎~
    If (App.PrevInstance = True) Then
        MsgBox "łɋNĂ܂B", vbOKOnly + vbExclamation, MSG_WARNING
        Exit Sub
    End If

    'ϐ
    pblnConnect = False

    'ADODB.Connection IuWFNg𐶐
    Set pobjCn = CreateObject("ADODB.Connection")

    'INI t@C烁Cʂ̃Rg[擾Aݒ肷
    blnRet = GetControlInfo
    If (blnRet = False) Then
        Unload frmMain
        Exit Sub
    End If

    'CʂN
    frmMain.Show

    'INI t@Cϐɐݒ
    pstrInifileNm = App.Path & "\" & INI_NAME

    'ڑʂN
    If Dir(pstrInifileNm) = vbNullString Then
        frmConnect.Show vbModal
    Else
        'INI t@Cf[^\[Xڑ擾
        strDSN = GetData_IniFile(pstrInifileNm, SEC_CONNECT, KEY_DSN)
        strUID = GetData_IniFile(pstrInifileNm, SEC_CONNECT, KEY_UID)
        strPWD = GetData_IniFile(pstrInifileNm, SEC_CONNECT, KEY_PWD)

        'INI t@Cɐݒ肳ĂŃf[^\[Xɐڑ݂
        blnRet = Connect(strDSN, strUID, strPWD)
        If (blnRet = False) Then
            'ڑʂN
            frmConnect.Show vbModal
        Else
            'ڑ\tOTrue ɂ
            pblnConnect = True
        End If
    End If

    'f[^\[XɐڑĂȂ΁ACʂ
    If (pblnConnect = False) Then
        Unload frmMain
    End If

End Sub

'*******************************************************************************
' Function GetData_IniFile()
'
' INI t@Cǂݍ
'*******************************************************************************
Public Function GetData_IniFile(ByVal vstrPath As String _
                              , ByVal vstrSec As String _
                              , ByVal vstrKey As String) As String
    Dim strValue                        As String * 1024
    Dim lngLen                          As Long

    'G[͍sȂ
    On Error Resume Next

    '߂l
    GetData_IniFile = vbNullString

    'INI t@C̑݃`FbN
    If ChkFileExists(vstrPath) = False Then
        Exit Function
    End If

    'ϐ̏
    strValue = vbNullString
    lngLen = Len(strValue)

    'INI t@Cl擾
    Call GetPrivateProfileString(vstrSec _
                               , vstrKey _
                               , vbNullString _
                               , strValue _
                               , lngLen _
                               , vstrPath)

    'INI t@C擾l߂lɐݒ
    GetData_IniFile = Left(strValue, InStr(strValue, vbNullChar) - 1)

    'G[΃NA
    If (Err.Number <> 0) Then
        Err.Clear
    End If

End Function

'*******************************************************************************
' Function SetData_IniFile()
'
' INI t@C
'*******************************************************************************
Public Sub SetData_IniFile(ByVal vstrPath As String _
                         , ByVal vstrSec As String _
                         , ByVal vstrKey As String _
                         , ByVal vstrData As String)
    Dim strKeyName                      As String
    Dim strValue                        As String

    'G[͍sȂ
    On Error Resume Next

    'INI t@C̓Yl
    Call WritePrivateProfileString(vstrSec, vstrKey, vbNullString, vstrPath)

    'INI t@Cɒl
    Call WritePrivateProfileString(vstrSec, vstrKey, vstrData, vstrPath)

    'G[΃NA
    If (Err.Number <> 0) Then
        Err.Clear
    End If

End Sub

'*******************************************************************************
' Function ChkFileExists()
'
' t@C̑݃`FbNs
'*******************************************************************************
Public Function ChkFileExists(ByVal vstrPathName As String) As Boolean
    Dim intFileNum                      As Integer

    'G[͍sȂ
    On Error Resume Next

    'pX̉E[fBNg؂蕶
    If Right$(vstrPathName, 1) = "\" Then
       vstrPathName = Left$(vstrPathName, Len(vstrPathName) - 1)
    End If

    'Ŏw肳ꂽt@CJ
    intFileNum = FreeFile
    Open vstrPathName For Input As intFileNum

    'ۂ߂lɐݒ
    ChkFileExists = IIf(Err = 0, True, False)

    't@C
    Close intFileNum

    'G[΃NA
    If (Err.Number <> 0) Then
        Err.Clear
    End If

End Function

'*******************************************************************************
' Function SetQuery()
'
' NGZbg
'*******************************************************************************
Public Function SetQuery(ByRef robjCn As Object _
                       , ByRef robjCm As Object _
                       , ByVal vstrQry As String) As Boolean

    '߂l
    SetQuery = False

    On Error GoTo Exception

    'ADODB.Connection ݒ
    With robjCm
        .ActiveConnection = robjCn
        .CommandText = vstrQry
    End With

    'I
    SetQuery = True

    Exit Function

Exception:
    'O
    MsgBox Err.Description, vbOKOnly + vbCritical, MSG_ERROR

    Err.Clear

End Function

'*******************************************************************************
' Function ExecQuery()
'
' NGs
'*******************************************************************************
Public Function ExecQuery(ByRef robjCm As Object _
                        , ByRef robjRs As Object) As Boolean

    '߂l
    ExecQuery = False

    On Error GoTo Exception

    'ADODB.Command sAʂADODB.Recordset ɃZbg
    With robjRs
        .CursorType = 1 'adOpenKeyset
        .LockType = 3   'adLockOptimistic

        .Open robjCm
    End With

    'I
    ExecQuery = True

    Exit Function

Exception:
    'O
    MsgBox Err.Description, vbOKOnly + vbCritical, MSG_ERROR

    Err.Clear

End Function

'*******************************************************************************
' Function Connect()
'
' f[^\[Xɐڑ
'*******************************************************************************
Public Function Connect(ByVal vstrDSN As String _
                      , ByVal vstrUID As String _
                      , ByVal vstrPWD As String) As Boolean
    Dim sConnect                        As String

    'G[͗Os
    On Error GoTo Exception

    '߂l
    Connect = False

    'ڑIuWFNgJĂȂ
    If (pobjCn.State <> 0) Then pobjCn.Close

    'ڑ̐ݒ
    sConnect = vbNullString
    sConnect = sConnect & "DSN=" & vstrDSN & ";"
    sConnect = sConnect & "UID=" & vstrUID & ";"
    sConnect = sConnect & "PWD=" & vstrPWD & ";"

    'ڑ
    pobjCn.Provider = "MSDASQL"
    pobjCn.ConnectionString = sConnect
    pobjCn.Open

    'I
    Connect = True

    Exit Function

Exception:
    'O
    MsgBox Err.Description, vbOKOnly + vbCritical, MSG_ERROR

    Err.Clear

End Function

'*******************************************************************************
' Sub DisConnect()
'
' f[^\[Xؒf
'*******************************************************************************
Public Sub DisConnect()

    'G[͍sȂ
    On Error Resume Next

    'ADODB.Connection IuWFNg
    pobjCn.Close

    'ADODB.Connection IuWFNg
    Set pobjCn = Nothing

    'G[΃NA
    If (Err.Number <> 0) Then
        Err.Clear
    End If

End Sub

'*******************************************************************************
' Function CNull()
'
' ̒l󔒂łNull Ԃ
'*******************************************************************************
Public Function CNull(ByVal vvarString As Variant) As Variant

    '󔒂Ȃ
    If Trim(vvarString) = vbNullString Then
        CNull = Null
        Exit Function
    '󔒈ȊOȂ
    Else
        CNull = RTrim(vvarString)
        Exit Function
    End If

End Function

'*******************************************************************************
' Function LoadTextFile()
'
' Ŏw肳ꂽeLXgt@Cǂݍ
'*******************************************************************************
Public Function LoadTextFile(ByVal vstrFile As String) As String
    Dim intFile                         As Integer
    Dim strLine                         As String
    Dim strText                         As String

    'G[͗Os
    On Error GoTo Exception

    '߂l
    LoadTextFile = vbNullString

    't@Cݒ肳ĂȂΏ𔲂
    If (vstrFile = vbNullString) Then
        Exit Function
    End If

    'w肳ꂽt@C݂ȂΏ𔲂
    If Dir(vstrFile) = vbNullString Then
        Exit Function
    End If

    'ϐ
    strText = vbNullString

    't@CJ
    intFile = FreeFile
    Open vstrFile For Input As intFile
    While Not EOF(intFile)
        Line Input #intFile, strLine
        strText = strText & strLine & vbCrLf
    Wend

    't@C
    Close intFile

    'ǂݍ񂾃t@C̓e߂lɃZbg
    LoadTextFile = strText

    'I
    Exit Function

Exception:
    'O
    MsgBox Err.Description, vbOKOnly + vbCritical, MSG_ERROR

    Err.Clear

End Function

'*******************************************************************************
' Sub CheckDate()
'
' t`FbN
'*******************************************************************************
Public Function CheckDate(ByVal vstrChar As String) As Boolean
    Dim strDate                         As String
    Dim intLen                          As Integer
    Dim blnRet                          As Boolean

    '߂l
    CheckDate = False

    'YYYYMMDD ̌`ɂȂĂ邩
    intLen = Len(vstrChar)
    If (intLen <> 8) Then
        Exit Function
    End If

    'YYYY/MM/DD ̌`ɕϊ
    strDate = FormatDate(vstrChar)

    'tÓ`FbN
    blnRet = IsDate(strDate)
    If (blnRet = False) Then
        Exit Function
    End If

    'I
    CheckDate = True

End Function

'*******************************************************************************
' Function FormatDate()
'
' YYYY/MM/DD `ɕϊ
'*******************************************************************************
Public Function FormatDate(ByVal vstrChar As String) As String

    'YYYY/MM/DD `ɕϊ
    FormatDate = _
        Left(vstrChar, 4) & "/" & Mid(vstrChar, 5, 2) & "/" & Right(vstrChar, 2)

End Function

'*******************************************************************************
' Function GetToday()
'
' VXetYYYYMMDD `Ŏ擾
'*******************************************************************************
Public Function GetToday() As String
    Dim datNow                          As Date
    Dim strNow                          As String
    Dim strRet                          As String

    'VXet擾
    datNow = Now()

    'VXet𕶎^ɕϊ
    strNow = CStr(datNow)

    'ϐɎ擾VXetYYYYMMDD `ɕϊ
    strRet = Format(strNow, "YYYYMMDD")

    '߂lɎ擾
    GetToday = strRet

End Function

