Attribute VB_Name = "basMain"
Option Explicit

'----------------------------------------
' \̒`
'----------------------------------------
'GNZ\
Private Type PTEXLCELL
    lngRow                              As Long
    lngCol                              As Long
    strRange                            As String
End Type

'----------------------------------------
' 萔`
'----------------------------------------
'Rg[̎
Private Const CTL_TYPE_LABEL            As String = "LABEL"
Private Const CTL_TYPE_COMBO            As String = "COMBO"
Private Const CTL_TYPE_TEXT             As String = "TEXT"
Private Const CTL_TYPE_NUMBER           As String = "NUMBER"
Private Const CTL_TYPE_DATE             As String = "DATE"

'INI t@C
Private Const INI_NAME                  As String = "MAIN.INI"

Private Const SEC_CAPTION               As String = "CAPTION"
Private Const SEC_FORM                  As String = "FORM"
Private Const SEC_TAB_COUNT             As String = "TAB_COUNT"
Private Const SEC_CONTROL_COUNT         As String = "CONTROL_COUNT"
Private Const SEC_TAB                   As String = "TAB"
Private Const SEC_CONTROL               As String = "CONTROL"

Private Const KEY_CAPTION               As String = "CAPTION"
Private Const KEY_HEIGHT                As String = "HEIGHT"
Private Const KEY_WIDTH                 As String = "WIDTH"
Private Const KEY_COUNT                 As String = "COUNT"
Private Const KEY_TYPE                  As String = "TYPE"
Private Const KEY_TOP                   As String = "TOP"
Private Const KEY_LEFT                  As String = "LEFT"
Private Const KEY_MAXLENGTH             As String = "MAXLENGTH"
Private Const KEY_TAB                   As String = "TAB"
Private Const KEY_ITEM_COUNT            As String = "ITEM_COUNT"
Private Const KEY_ITEM_TEXT             As String = "ITEM_TEXT"

'SQL XNvg
Private Const SQL_NAME                  As String = "PRINT.SQL"

'L[s
Private Const STR_KEY                   As String = "KEY"

'----------------------------------------
' ϐ`
'----------------------------------------
'INI t@C
Private mstrInifileNm                   As String

'Rg[
Private mstrCtlType()                   As String       'Index 1 

'Rg[
Private mintControlCnt                  As Integer

'^u
Private mintTabCnt                      As Integer

'*******************************************************************************
' Function GetControlInfo()
'
' INI t@Cǂݍ݁ARg[쐬
'*******************************************************************************
Public Function GetControlInfo() As Boolean
    Dim strType                         As String
    Dim intTop                          As Integer
    Dim intLeft                         As Integer
    Dim intWidth                        As Integer
    Dim intMaxLength                    As Integer
    Dim intIndex                        As Integer
    Dim intIndex2                       As Integer
    Dim intCtlCnt                       As Integer
    Dim intTabPos                       As Integer
    Dim intTabCnt                       As Integer
    Dim strCap                          As String
    Dim intItemCnt                      As Integer
    Dim strItemText                     As String
    Dim strToday                        As String

    'G[͗Os
    On Error GoTo Exception

    '߂l
    GetControlInfo = False

    'ϐ
    mintControlCnt = 0
    mintTabCnt = 0
    strToday = GetToday()

    'INI t@Cϐɐݒ
    mstrInifileNm = App.Path & "\" & INI_NAME

    'ʌo擾A\
    frmMain.Caption = GetData_IniFile(mstrInifileNm, SEC_CAPTION, KEY_CAPTION)

    'ʂ̃TCY擾A\
    frmMain.Height = GetData_IniFile(mstrInifileNm, SEC_FORM, KEY_HEIGHT)
    frmMain.Width = GetData_IniFile(mstrInifileNm, SEC_FORM, KEY_WIDTH)

    'Tab ̐擾
    intTabCnt = GetData_IniFile(mstrInifileNm, SEC_TAB_COUNT, KEY_COUNT)

    'Tab ݒ肷
    Call frmMain.tabMain.Tabs.Clear
    For intIndex = 1 To intTabCnt
        strCap = GetData_IniFile(mstrInifileNm, SEC_TAB & CStr(intIndex), KEY_CAPTION)
        Call frmMain.tabMain.Tabs.Add(intIndex, STR_KEY & CStr(intIndex), strCap)
        Load frmMain.fraZyouken(intIndex)
    Next intIndex

    'Rg[擾
    intCtlCnt = GetData_IniFile(mstrInifileNm, SEC_CONTROL_COUNT, KEY_COUNT)

    'Rg[ݒ肷
    For intIndex = 1 To intCtlCnt
        'INI t@Cǂݍ݁ARg[̏擾
        strType = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(intIndex), KEY_TYPE)
        intTop = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(intIndex), KEY_TOP)
        intLeft = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(intIndex), KEY_LEFT)
        intTabPos = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(intIndex), KEY_TAB)

        'zɃRg[̃^Cvi[
        ReDim Preserve mstrCtlType(intIndex)
        mstrCtlType(intIndex) = strType

        'Rg[Load 
        Select Case strType
            'Label
            Case CTL_TYPE_LABEL
                'Label Rg[Load 
                Load frmMain.lblZyouken(intIndex)
                'INI t@Cǂݍ݁ARg[̏擾
                strCap = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(intIndex), KEY_CAPTION)
                'Label Rg[̃vpeBݒ
                With frmMain.lblZyouken(intIndex)
                    .Visible = True
                    .Top = intTop
                    .Left = intLeft
                    .Caption = strCap
                    Set .Container = frmMain.fraZyouken(intTabPos)
                End With

            'ComboBox
            Case CTL_TYPE_COMBO
                'ComboBox Rg[Load 
                Load frmMain.cboZyouken(intIndex)
                'INI t@Cǂݍ݁ARg[̏擾
                intWidth = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(intIndex), KEY_WIDTH)
                intItemCnt = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(intIndex), KEY_ITEM_COUNT)
                'ComboBox Rg[̃vpeBݒ
                With frmMain.cboZyouken(intIndex)
                    For intIndex2 = 1 To intItemCnt
                        strItemText = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(intIndex), KEY_ITEM_TEXT & CStr(intIndex2))
                        .AddItem strItemText
                    Next intIndex2
                    .Visible = True
                    .Top = intTop
                    .Left = intLeft
                    .Width = intWidth
                    .ListIndex = 0
                    Set .Container = frmMain.fraZyouken(intTabPos)
                End With

            'TextBox
            Case CTL_TYPE_TEXT
                'TextBox Rg[Load 
                Load frmMain.txtZyouken(intIndex)
                'INI t@Cǂݍ݁ARg[̏擾
                intWidth = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(intIndex), KEY_WIDTH)
                intMaxLength = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(intIndex), KEY_MAXLENGTH)
                'TextBox Rg[̃vpeBݒ
                With frmMain.txtZyouken(intIndex)
                    .Visible = True
                    .Top = intTop
                    .Left = intLeft
                    .Width = intWidth
                    .MaxLength = intMaxLength
                    .Text = vbNullString
                    Set .Container = frmMain.fraZyouken(intTabPos)
                End With

            'TextBox(Number)
            Case CTL_TYPE_NUMBER
                'TextBox(Number) Rg[Load 
                Load frmMain.numZyouken(intIndex)
                'INI t@Cǂݍ݁ARg[̏擾
                intWidth = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(intIndex), KEY_WIDTH)
                intMaxLength = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(intIndex), KEY_MAXLENGTH)
                'TextBox(Number) Rg[̃vpeBݒ
                With frmMain.numZyouken(intIndex)
                    .Visible = True
                    .Top = intTop
                    .Left = intLeft
                    .Width = intWidth
                    .MaxLength = intMaxLength
                    .Text = "0"
                    Set .Container = frmMain.fraZyouken(intTabPos)
                End With

            'TextBox(Date)
            Case CTL_TYPE_DATE
                'TextBox(Date) Rg[Load 
                Load frmMain.datZyouken(intIndex)
                'TextBox(Date) Rg[̃vpeBݒ
                With frmMain.datZyouken(intIndex)
                    .Visible = True
                    .Top = intTop
                    .Left = intLeft
                    .Text = strToday
                    Set .Container = frmMain.fraZyouken(intTabPos)
                End With

            'LRg[ȊO
            Case Else
                'Ȃ

        End Select
    Next intIndex

    'ϐɃRg[Zbg
    mintControlCnt = intCtlCnt
    mintTabCnt = intTabCnt

    'Frame Rg[̕\\؂ւ
    Call Set_FrameVisible

    'I
    GetControlInfo = True

    Exit Function

Exception:
    'O
    MsgBox Err.Description, vbOKOnly + vbCritical, MSG_ERROR
    MsgBox "INIt@C̐ݒ肪܂B", vbOKOnly + vbCritical, MSG_ERROR

    Err.Clear

End Function

'*******************************************************************************
' Sub Set_FrameVisible()
'
' Frame Rg[̕\\؂ւ
'*******************************************************************************
Public Sub Set_FrameVisible()
    Dim intIndex                        As Integer
    Dim intTabPos                       As Integer

    'IĂ^ũCfbNX擾
    intTabPos = frmMain.tabMain.SelectedItem.Index

    'IĂ^uɊYt[݂̂\Ԃɂ
    For intIndex = 1 To mintTabCnt
        frmMain.fraZyouken(intIndex).Visible = (intIndex = intTabPos)
        frmMain.fraZyouken(intIndex).ZOrder
    Next intIndex

End Sub

'*******************************************************************************
' Sub PrintOut()
'
' C
'*******************************************************************************
Public Sub PrintOut()
    Dim strFile                         As String
    Dim strText                         As String
    Dim blnRet                          As Boolean
    Dim objRs                           As Object

    'G[͗Os
    On Error GoTo Exception

    'Xe[^Xo[ɐi\
    frmMain.stbMain.SimpleText = "Ă܂..."

    '͂ꂽȏÓ`FbNs
    blnRet = CheckZyouken()
    If (blnRet = False) Then
        frmMain.stbMain.SimpleText = vbNullString
        Exit Sub
    End If

    'ADODB.Recordset 𐶐
    Set objRs = CreateObject("ADODB.Recordset")

    'SQL XNvgt@Cǂݍ
    strFile = App.Path & "\" & SQL_NAME
    strText = LoadTextFile(strFile)

    'SQL s
    blnRet = SQL_SelPrn(objRs, strText)
    If (blnRet = False) Then
        frmMain.stbMain.SimpleText = vbNullString
        Exit Sub
    End If

    'GNZIuWFNg𐶐ASQL ̎sʂo͂
    Call Prn_Excel(objRs)

    'ADODB.Recordset IuWFNg
    Set objRs = Nothing

    'Xe[^Xo[NA
    frmMain.stbMain.SimpleText = vbNullString

    Exit Sub

Exception:
    'O
    MsgBox Err.Description, vbOKOnly + vbCritical, MSG_ERROR

    Err.Clear

End Sub

'*******************************************************************************
' Sub SQL_SelPrn()
'
' [o͂SQL s
'*******************************************************************************
Private Function SQL_SelPrn(ByRef robjRs As Object _
                          , ByVal vstrSql As String) As Boolean
    Static objCm                        As Object
    Dim blnRet                          As Boolean
    Dim intIndex                        As Integer
    Dim strChar                         As String
    Dim strZyouken                      As String
    Dim intPara                         As Integer
    Dim strType                         As String

    'G[͗Os
    On Error GoTo Exception

    '߂l
    SQL_SelPrn = False

    'ADODB.Command 𐶐
    If (objCm Is Nothing) Then
        Set objCm = CreateObject("ADODB.Command")
        blnRet = SetQuery(pobjCn, objCm, vstrSql)
        If (blnRet = False) Then
            Exit Function
        End If
    End If

    'NGZbg
    blnRet = SetQuery(pobjCn, objCm, vstrSql)
    If (blnRet = False) Then
        Exit Function
    End If

    'p[^Zbg
    intPara = 0
    For intIndex = 1 To mintControlCnt
        strType = mstrCtlType(intIndex)
        If (strType = CTL_TYPE_COMBO) Then
            'ComboBox
            strZyouken = frmMain.cboZyouken(intIndex).Text
            objCm.Parameters(intPara).Value = CNull(strZyouken)
            intPara = intPara + 1
        End If
        If (strType = CTL_TYPE_TEXT) Then
            'TextBox
            strZyouken = frmMain.txtZyouken(intIndex).Text
            objCm.Parameters(intPara).Value = CNull(strZyouken)
            intPara = intPara + 1
        End If
        If (strType = CTL_TYPE_NUMBER) Then
            'TextBox(Number)
            strZyouken = frmMain.numZyouken(intIndex).Text
            objCm.Parameters(intPara).Value = CNull(strZyouken)
            intPara = intPara + 1
        End If
        If (strType = CTL_TYPE_DATE) Then
            'TextBox(Date)
            strChar = frmMain.datZyouken(intIndex).Text
            strZyouken = FormatDate(strChar)
            objCm.Parameters(intPara).Value = CNull(strZyouken)
            intPara = intPara + 1
        End If
    Next intIndex

    'NGs
    blnRet = ExecQuery(objCm, robjRs)
    If (blnRet = False) Then
        Exit Function
    End If

    'I
    SQL_SelPrn = True

    Exit Function

Exception:
    'O
    MsgBox Err.Description, vbOKOnly + vbCritical, MSG_ERROR

    Err.Clear

End Function

'*******************************************************************************
' Sub Prn_Excel()
'
' GNZIuWFNg𐶐ASQL ̎sʂo͂
'*******************************************************************************
Private Sub Prn_Excel(ByRef robjRs As Object)
    Dim objExcelApp                     As Object
    Dim objWorkBook                     As Object
    Dim objWorkSheet                    As Object
    Dim objRange                        As Object
    Dim typCell                         As PTEXLCELL
    Dim ilngIdx                         As Long

    'G[͗Os
    On Error GoTo Exception

    'GNZIuWFNg𐶐
    Set objExcelApp = CreateObject("Excel.Application")
    objExcelApp.Interactive = False
    Set objWorkBook = objExcelApp.Workbooks.Add
    Set objWorkSheet = objWorkBook.ActiveSheet
    Set objRange = objWorkSheet.Range("A1")

    'ö
    For ilngIdx = 0 To robjRs.Fields.Count - 1
        objRange.Parent.Columns(ilngIdx + 1).NumberFormat = "@"
        objRange.Value = robjRs.Fields(ilngIdx).Name
        Set objRange = objRange.Offset(0, 1)
    Next ilngIdx

    'ׂ̈
    typCell.strRange = "A2"
    typCell.lngCol = 1
    typCell.lngRow = 2
    Call Prn_Recordset(robjRs, objWorkSheet, typCell)

    'GNZIuWFNg̉
    objExcelApp.Interactive = True
    objExcelApp.Visible = True
    objWorkSheet.Activate

    'I
    Set objExcelApp = Nothing

    Exit Sub

Exception:
    'O
    MsgBox Err.Description, vbOKOnly + vbCritical, MSG_ERROR

    On Error Resume Next

    objExcelApp.Interactive = True
    objExcelApp.Visible = True
    Set objExcelApp = Nothing

    Err.Clear

End Sub

'*******************************************************************************
' Sub Prn_Recordset()
'
' GNZו
'*******************************************************************************
Private Sub Prn_Recordset(ByRef robjRs As Object _
                        , ByRef robjWS As Object _
                        , ByRef rtypCell As PTEXLCELL)
    Dim varSomeArray()                  As Variant
    Dim lngArrayCols                    As Long
    Dim ilngRow                         As Long
    Dim ilngCol                         As Long
    Dim ilngIdx                         As Long

    Const ARR_BUF                       As Long = 100

    'G[͗Os
    On Error GoTo Exception

    '񐔂擾
    lngArrayCols = robjRs.Fields.Count

    'ADODB.Recordset GNZɓWJ
    With robjRs
        Do While (.EOF = False)
            ReDim varSomeArray(ARR_BUF - 1, lngArrayCols - 1)
            For ilngRow = 0 To ARR_BUF - 1
                ilngCol = 0
                For ilngIdx = 0 To .Fields.Count - 1
                    varSomeArray(ilngRow, ilngCol) = .Fields(ilngIdx).Value
                    If IsNull(varSomeArray(ilngRow, ilngCol)) Then
                        varSomeArray(ilngRow, ilngCol) = vbNullString
                    End If
                    ilngCol = ilngCol + 1
                Next
                .MoveNext

                If (.EOF = True) Then
                    Exit For
                End If
            Next ilngRow

            robjWS.Range(robjWS.Cells(rtypCell.lngRow _
                                    , rtypCell.lngCol) _
                       , robjWS.Cells(rtypCell.lngRow + ARR_BUF - 1 _
                                    , rtypCell.lngCol + lngArrayCols - 1)).Value = varSomeArray
            rtypCell.lngRow = rtypCell.lngRow + ARR_BUF
        Loop
        .Close
    End With

    Exit Sub

Exception:
    'O
    MsgBox Err.Description, vbOKOnly + vbCritical, MSG_ERROR

    Err.Clear

End Sub

'*******************************************************************************
' Function CheckZyouken()
'
' Rg[Ó`FbN
'*******************************************************************************
Private Function CheckZyouken() As Boolean
    Dim intIndex                        As Integer
    Dim strType                         As String
    Dim intListIndex                    As Integer
    Dim strChar                         As String
    Dim blnRet                          As Boolean

    '߂l
    CheckZyouken = False

    'ׂĂ̏Rg[̑Ó`FbN
    For intIndex = 1 To mintControlCnt
        strType = mstrCtlType(intIndex)
        If (strType = CTL_TYPE_COMBO) Then
            'ComboBox
            intListIndex = frmMain.cboZyouken(intIndex).ListIndex
            If (intListIndex < 0) Then
                MsgBox "o͏w肵ĂB", vbOKOnly + vbExclamation, MSG_WARNING
                Call SelTab_SetFocus(intIndex, frmMain.cboZyouken(intIndex))
                Exit Function
            End If
        End If
        If (strType = CTL_TYPE_NUMBER) Then
            'TextBox(Number)
            strChar = frmMain.numZyouken(intIndex).Text
            blnRet = IsNumeric(strChar)
            If (blnRet = False) Then
                MsgBox "lƂĐ܂B", vbOKOnly + vbExclamation, MSG_WARNING
                Call SelTab_SetFocus(intIndex, frmMain.numZyouken(intIndex))
                Exit Function
            End If
        End If
        If (strType = CTL_TYPE_DATE) Then
            'TextBox(Date)
            strChar = frmMain.datZyouken(intIndex).Text
            blnRet = CheckDate(strChar)
            If (blnRet = False) Then
                MsgBox "tƂĐ܂B", vbOKOnly + vbExclamation, MSG_WARNING
                Call SelTab_SetFocus(intIndex, frmMain.datZyouken(intIndex))
                Exit Function
            End If
        End If
    Next intIndex

    'I
    CheckZyouken = True

End Function

'*******************************************************************************
' Sub SelTab_SetFocus()
'
' w肵CfbNX̃Rg[ɃtH[JXړ
'*******************************************************************************
Private Sub SelTab_SetFocus(ByVal vintIndex As Integer _
                          , ByRef robjControl As Control)
    Dim intTabPos                       As Integer

    'Rg[zuĂ^uCfbNX擾
    intTabPos = GetData_IniFile(mstrInifileNm, SEC_CONTROL & CStr(vintIndex), KEY_TAB)

    'Rg[zuĂ^uIԂɂ
    frmMain.tabMain.Tabs(intTabPos).Selected = True

    'w肵CfbNX̃Rg[ɃtH[JXړ
    robjControl.SetFocus

End Sub

