Attribute VB_Name = "basConnect"
Option Explicit

'----------------------------------------
' Windows API
'----------------------------------------
Private Declare Function SQLDataSources Lib "ODBC32.DLL" _
    (ByVal henv& _
   , ByVal fDirection% _
   , ByVal szDSN$ _
   , ByVal cbDSNMax% _
   , pcbDSN% _
   , ByVal szDescription$ _
   , ByVal cbDescriptionMax% _
   , pcbDescription%) As Integer

Private Declare Function SQLAllocEnv% Lib "ODBC32.DLL" (env&)

'----------------------------------------
' 萔`
'----------------------------------------
Private Const SQL_SUCCESS               As Long = 0
Private Const SQL_FETCH_NEXT            As Long = 1

Public Const INI_NAME                   As String = "CONNECT.INI"
Public Const SEC_CONNECT                As String = "CONNECT"
Public Const KEY_DSN                    As String = "DSN"
Public Const KEY_UID                    As String = "UID"
Public Const KEY_PWD                    As String = "PWD"

'----------------------------------------
' ϐ`
'----------------------------------------
'INI t@C
Public pstrInifileNm                    As String

'ڑtOiTrueȂڑĂAFalseȂڑĂȂj
Public pblnConnect                      As Boolean

'*******************************************************************************
' Sub Init_ConnectForm()
'
' f[^\[Xڑʂ
'*******************************************************************************
Public Sub Init_ConnectForm()

    'f[^\[XIR{{bNXɃACeݒ
    Call GetDSNsAndDrivers

    'INI t@COڑ擾ăRg[ɃZbg
    With frmConnect
        .cboDSN.Text = GetData_IniFile(pstrInifileNm, SEC_CONNECT, KEY_DSN)
        .txtUID.Text = GetData_IniFile(pstrInifileNm, SEC_CONNECT, KEY_UID)
        .txtPWD.Text = GetData_IniFile(pstrInifileNm, SEC_CONNECT, KEY_PWD)
    End With

End Sub

'*******************************************************************************
' Sub Save_ConnectInfo()
'
' INI t@CɃf[^\[Xڑۑ
'*******************************************************************************
Public Sub Save_ConnectInfo()

    'INI t@Cɐڑۑ
    With frmConnect
        Call SetData_IniFile(pstrInifileNm, SEC_CONNECT, KEY_DSN, .cboDSN.Text)
        Call SetData_IniFile(pstrInifileNm, SEC_CONNECT, KEY_UID, .txtUID.Text)
        Call SetData_IniFile(pstrInifileNm, SEC_CONNECT, KEY_PWD, .txtPWD.Text)
    End With

End Sub

'*******************************************************************************
' Sub GetDSNsAndDrivers()
'
' f[^\[XR{{bNXɃZbg
'*******************************************************************************
Private Sub GetDSNsAndDrivers()
    Dim i                               As Integer
    Dim sDSNItem                        As String * 1024
    Dim sDRVItem                        As String * 1024
    Dim sDSN                            As String
    Dim iDSNLen                         As Integer
    Dim iDRVLen                         As Integer
    Dim lHenv                           As Long

    'G[͍sȂ
    On Error Resume Next

    'ODBC ɐڑĂf[^\[XׂăR{{bNXɃZbg
    If SQLAllocEnv(lHenv) <> -1 Then
        Do Until i <> SQL_SUCCESS
            sDSNItem = Space$(1024)
            sDRVItem = Space$(1024)
            i = SQLDataSources(lHenv, SQL_FETCH_NEXT, sDSNItem, 1024, iDSNLen, sDRVItem, 1024, iDRVLen)
            sDSN = Left$(sDSNItem, iDSNLen)

            If sDSN <> Space(iDSNLen) Then
                frmConnect.cboDSN.AddItem sDSN
            End If
        Loop
    End If

    'G[΃NA
    If (Err.Number <> 0) Then
        Err.Clear
    End If

End Sub

